sys = require "luci.sys"                                           
ut = require "luci.util" 

--------------------------------------------------------------------------------------------------------
m=Map("iec101_104","IEC 101 to IEC104 Converter")
s = m:section(TypedSection, "iec101_104")
s.anonymous = true

iec101_104_enable=s:option(Flag,"iec101_104_enable",translate("Enable"))
iec101_104_enable.default = 0

s1 = m:section(TypedSection,"configuration101",translate("IEC 101 Slave Configuration"))
s1.anonymous =true

asduaddr_101 = s1:option(Value,"asduaddr_101",translate("ASDU Address"))
asduaddr_101.datatype    = "and(min(1),uinteger)"                 
asduaddr_101.placeholder = "0-65535" 
asduaddr_101.default = "1"

linkaddr = s1:option(Value,"linkaddr",translate("Link Address"))
linkaddr.datatype    = "and(min(1),uinteger)"                 
linkaddr.placeholder = "0-65535" 
linkaddr.default = "1"

p1 = s1:option(ListValue,"asduaddrsize",translate("ASDU Address size"))
p1:value("1","One Octet")          
p1:value("2","Two Octets")
p1.default = "2"


p2 = s1:option(ListValue,"cotsize_101",translate("COT size"))
p2:value("1","One Octet")
p2:value("2","Two Octets")
p2.default = "2"


p3 = s1:option(ListValue,"ioaaddrsize",translate("IOA address size"))
p3:value("1","One Octet")                               
p3:value("2","Two Octets") 
p3:value("3","Three Octets")                                   
p3.default = "3"

p4 = s1:option(ListValue,"linkaddrsize",translate("Link Address size"))
p4:value("0","Not Present")  
p4:value("1","One Octet")                               
p4:value("2","Two Octets")                                    
p4.default = "1"

p5 = s1:option(ListValue,"operationmode",translate("Link Transmission Procedure"))
p5:value("1","UnBalanced")                                    
p5:value("2","Balanced")
p5.default = "1"  

--------------------------------------------------------------------------
s2 = m:section(TypedSection,"configuration104",translate("IEC 104 Master Configuration"))
s2.anonymous =true

asduaddr_104 = s2:option(Value,"asduaddr_104",translate("ASDU Address"))
asduaddr_104.datatype    = "and(min(1),uinteger)"                 
asduaddr_104.placeholder = "0-65535" 
asduaddr_104.default = "1"

p1_104 = s2:option(ListValue,"cotsize_104",translate("COT size"))
p1_104:value("1","One Octet")
p1_104:value("2","Two Octets")
p1_104.default = "2"

t1= s2:option(Value,"t1",translate("Time out T1"))
t1.datatype    = "and(min(1),uinteger)"                 
t1.placeholder = "0-65535"              
t1.default = "15000"

t2= s2:option(Value,"t2",translate("Time out T2"))
t2.datatype    = "and(min(1),uinteger)"                 
t2.placeholder = "0-65535"              
t2.default = "2000"

t3= s2:option(Value,"t3",translate("Time out T3"))
t3.datatype    = "and(min(1),uinteger)"                 
t3.placeholder = "0-65535"              
t3.default = "20000"

type = s2:option(ListValue,"types",translate("Type"),"Internal: Listen on LAN. External: Listen on WAN/Wifi/Cellular auto fallback")
type:value("internal","Internal")
type:value("external","External")


int_ip = s2:option(Value,"internal_ip",translate("IP"))                                                                             
int_ip:depends({types="internal"})                                                                                                  
--int_ip.datatype = "neg(ip4addr)"                                        

luci.sys.net.ipv4_hints(                                                                 
	int_ip:value("LAN", "%s (%s)" %{ ut.trim(sys.exec("uci get network.lan.ipaddr")), "Maestro.lan" })
	)

port= s2:option(Value,"port",translate("Port"))
port.datatype    = "port"                 
port.placeholder = "0-65535"              
port.default = "2404"

return m

