#!/bin/sh
get_interface_ip () {

	types=`uci get iec101_104.@configuration104[0].types`
	if [ "$types" == "internal" ];then
		ip=`uci get iec101_104.@configuration104[0].internal_ip`
		if [ "$ip" == "LAN" ]; then
			ip=`uci get network.lan.ipaddr`
		elif [ "$ip" == "" ]; then
			ip="127.0.0.1"
		else
			ifconfig eth0:2 $ip
		fi
		echo $ip

	else
		count=1
		while [ $count -le 5 ]
		do
			interface=`uci get mwan3.m$count.interface`
			if [[ "$interface" = "wan" ]] || [[ "$interface" = "wwan" ]] || [[ "$interface" = "cellular" ]]
				then
				status=`/usr/sbin/get_interface_status.sh get_"$interface"_status`
				if [ "$status" = "online" ]
					then
					break
				fi
			fi
			count=`expr $count + 1`
		done
		if [ "$status" = "online" ]
			then
			if [ "$interface" = "wan" ]
				then
				ip=`ifconfig eth0.2 | grep "inet addr" | awk -F "inet addr:" '{ print $2}'| awk -F " " '{print $1}'`
				echo $ip
			elif [ "$interface" = "wwan" ]
				then
				ip=`ifconfig wlan0 | grep "inet addr" | awk -F "inet addr:" '{ print $2}'| awk -F " " '{print $1}'`
				echo $ip	
			else

				ip=`ifconfig $(uci get network.cellular.ifname) | grep "inet addr" | awk -F "inet addr:" '{ print $2}'| awk -F " " '{print $1}'`
				echo $ip	
			fi
		else
			ip=0
			echo $ip
		fi

	fi	
}



ip=$( get_interface_ip )
adsuadd_104=`uci get iec101_104.@configuration104[0].asduaddr_104`
cotsize_104=`uci get iec101_104.@configuration104[0].cotsize_104`
port=`uci get iec101_104.@configuration104[0].port`
adsuadd_101=`uci get iec101_104.@configuration101[0].asduaddr_101`
adsuaddsize=`uci get iec101_104.@configuration101[0].asduaddrsize`
cotsize_101=`uci get iec101_104.@configuration101[0].cotsize_101`
linkaddr=`uci get iec101_104.@configuration101[0].linkaddr`
linkaddrsize=`uci get iec101_104.@configuration101[0].linkaddrsize`
ioaaddrsize=`uci get iec101_104.@configuration101[0].ioaaddrsize`
operationmode=`uci get iec101_104.@configuration101[0].operationmode`
t1=`uci get iec101_104.@configuration104[0].t1`
t2=`uci get iec101_104.@configuration104[0].t2`
t3=`uci get iec101_104.@configuration104[0].t3`

`echo IEC104_MappStart, > /etc/101_104_Config.csv`
`echo $ip,$port,$t1,$t2,$t3, >> /etc/101_104_Config.csv`
`echo 2,$adsuadd_104,$cotsize_104, >> /etc/101_104_Config.csv`
`echo IEC104_MappEnd, >>/etc/101_104_Config.csv`
`echo IEC101_MappStart, >> /etc/101_104_Config.csv`
`echo $adsuaddsize,$adsuadd_101,$cotsize_101,$linkaddrsize,$linkaddr,$ioaaddrsize,$operationmode, >> /etc/101_104_Config.csv`
`echo IEC101_MappEnd, >>/etc/101_104_Config.csv`


if [ "$ip" != "0" ]                                                                                                          
	then 
	/usr/bin/101_104 &
fi
